<?php
// nastaveni error reporting - funkce is_a uz nema oznaceni deprecated!
error_reporting(E_ALL & ~E_STRICT);

/**
 * Magicka fuknce umoznuje nacist soubor s definici tridy, pokud pouzijeme tridu,
 * ktera PHP jeste neni znama.
 * @param $className - jmeno tridy, ktera neni PHP znama
 */
function __autoload($className) {
	// ze jmena tridy musime nejak udelat cestu k souboru, ktery se ma nacist
	require_once("classes/$className.php");
}

// do teto promenne si postupne budeme ukladat HTML vystup, aby se nam nepletlo HTML s PHP dohromady
$tpl_data = '';

//$cart = SerializableCart::getACart('SerializableCart');
$cart = SerializableCart::getACart();

$items = array (
	new Book('Author 1', 'Title 1', 2009),     //0
	new Book('Author 2', 'Title 2', 2008),     //1
	new Zeppelin('Hindenburg', 'Zeppelin'),    //2
	new Zeppelin('Graf Zeppelin', 'Zeppelin'), //3
	new Device(),
);

$tpl_data .= '<h2>Add 4 books from Autor 1 and 5 Hindenburg Zeppelins</h2>';
$cart->addToCart($items[0], 4);
$cart->addToCart($items[2], 5);
$tpl_data .= $cart;
$tpl_data .= '<h2>Remove 2 books from Autor 1</h2>';
$cart->removeFromCart($items[0], 2);
$tpl_data .= $cart;
$tpl_data .= '<h2>Remove 4 books from Autor 1</h2>';
$cart->removeFromCart($items[0], 4);
$tpl_data .= $cart;

$tpl_data .= '<h2>Save/load cart</h2>';
if (SerializableCart::saveCart('cart.txt', $cart)) {
	$cartRecovered = SerializableCart::loadCart('cart.txt');
	if ($cartRecovered !== null)
		$tpl_data .= '<h3>Recovered cart</h3>'.$cartRecovered;
	else
		$tpl_data .= '<h3>Recovered cart</h3><p>Failed to read/unserialize data.</p>';
}
else
		$tpl_data .= '<p>Failed to serialize/write data.</p>';

// kdyz tohle odkomentujete, zpusobi to chybu - vkladany objekt neni instance tridy Item!
// $cart->addToCart($items[4], 9);
// $tpl_data .= $cart;

// vystup, ktery jsme ulozili do promenne se nakonec se vlozi do nasledujici HTML sablony
require_once('html_tpl.php');
?>